package gui;

import lib.IGestor;

/**
 * Esta clase extiende el comportamiento de la ventana de nuevo o modifica elemento.
 * Declaro atributo que indica si presionó o no el botón Aceptar
 * @author maxio
 */
public class JDialogGestion extends javax.swing.JDialog {
     
    /**
     * Declaro atributo que indica si presionó o no el botón Aceptar
     */
    public boolean Cancelar=true;
    /**
     * Atributo de la clave que debe ser entero
     */
    public int MiId;
    /**
     * Puntero que apunta a un IGestor para polimorfismo.
     Protegido para poder ser usado en subclases.
     */
    protected IGestor miGestor;
    /**
     * Constructor de la clase que llama al constructor de JDialog
     * @param parent Ventana Padre, una frmGestor
     * @param modal Modo Modal
     * @param id int. Clave del registro a modificar. 0 Para nuevo
     * @param g IGestor. Gestor que proveerá las operaciones nuevo y modifica.
     */
    public JDialogGestion(java.awt.Frame parent, boolean modal, int id, IGestor g) {
        super(parent, modal);
        MiId=id;
        miGestor=g;
        this.pack();
        this.setLocationRelativeTo(null);
        initComponents();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 317, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 166, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables
}
