package gui;
import javax.swing.JOptionPane;
import lib.*;

/**
 * @author maxio
 */
public class frmGestor extends javax.swing.JFrame {
    /**
     * String. Título de la ventana. Ej: Gestor de Personas
     */
    public String miTitulo;
    /**
     * String. Nombre del elemento a gestionar, para mensajes, texto de ayuda, etc.
     * Ej. Persona
     */
    public String miElemento;
    /**
     * IGestor. Gestor para la búsqueda
     */
    public IGestor miGestor;
    /**
     * JDialogGestion. Ventana para crear o modificar un elemento
     */
    public JDialogGestion miVentana;
            
    /**
     * Crea una nueva ventana gestor.
     * @param titulo String. Título de la ventana. Ej: Gestor de Personas
     * @param elemento String. Nombre del elemento a gestionar, para mensajes, texto de ayuda, etc.
     * Ej. Persona
     * @param gestor IGestor. Gestor para la búsqueda
     * @param ventana  JDialogGestion. Ventana para crear o modificar un elemento
     */
    public frmGestor(String titulo, String elemento, IGestor gestor, JDialogGestion ventana) {
        miTitulo=titulo;
        miElemento=elemento;
        miGestor=gestor;
        miVentana=ventana;
        initComponents();
        this.setTitle(titulo);
        this.pack();
        this.setLocationRelativeTo(null);
        bNuevo.setToolTipText("Crear elemento " + miElemento);
        bModifica.setToolTipText("Modificar elemento " + miElemento);
        bBorra.setToolTipText("Borrar elemento " + miElemento);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        tCadena = new javax.swing.JTextField();
        bNuevo = new javax.swing.JButton();
        bModifica = new javax.swing.JButton();
        bBorra = new javax.swing.JButton();
        bSalir = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        gLista = new javax.swing.JList();
        bBusca = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        tCadena.setToolTipText("Ingrese cadena de búsqueda");
        tCadena.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                tCadenaFocusGained(evt);
            }
        });

        bNuevo.setText("Nuevo...");
        bNuevo.setToolTipText("");
        bNuevo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bNuevoActionPerformed(evt);
            }
        });

        bModifica.setText("Modifica...");
        bModifica.setToolTipText("");
        bModifica.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bModificaActionPerformed(evt);
            }
        });

        bBorra.setText("Borra");
        bBorra.setToolTipText("");
        bBorra.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bBorraActionPerformed(evt);
            }
        });

        bSalir.setText("Salir");
        bSalir.setToolTipText("");
        bSalir.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bSalirActionPerformed(evt);
            }
        });

        jScrollPane1.setViewportView(gLista);

        bBusca.setText("Buscar");
        bBusca.setToolTipText("");
        bBusca.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bBuscaActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jScrollPane1)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(tCadena, javax.swing.GroupLayout.PREFERRED_SIZE, 87, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(bBusca)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(bNuevo)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(bModifica)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(bBorra)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(bSalir)))
                .addContainerGap())
        );

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {bBorra, bBusca, bModifica, bNuevo, bSalir});

        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(tCadena, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(bNuevo)
                    .addComponent(bModifica)
                    .addComponent(bBorra)
                    .addComponent(bSalir)
                    .addComponent(bBusca))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 149, Short.MAX_VALUE)
                .addContainerGap())
        );

        layout.linkSize(javax.swing.SwingConstants.VERTICAL, new java.awt.Component[] {bBorra, bModifica, bNuevo, bSalir});

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void bSalirActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bSalirActionPerformed
        /*Oculta la ventana y convoca destructor*/
        this.setVisible(false);
        this.dispose();
    }//GEN-LAST:event_bSalirActionPerformed

    private void tCadenaFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_tCadenaFocusGained
        tCadena.selectAll();
    }//GEN-LAST:event_tCadenaFocusGained

    private void bBuscaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bBuscaActionPerformed
        gLista.setListData(this.miGestor.Buscar("", tCadena.getText()).toArray());
    }//GEN-LAST:event_bBuscaActionPerformed

    private void bNuevoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bNuevoActionPerformed
        miVentana.MiId=0;
        miVentana.setVisible(true);
        
    }//GEN-LAST:event_bNuevoActionPerformed

    private void bModificaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bModificaActionPerformed
        /*Si existe un elemento de la lista...*/
        if (gLista.getSelectedIndex()!=-1){
            miVentana.MiId=((IElemento)gLista.getSelectedValue()).dameId();
            miVentana.setVisible(true);
        }
    }//GEN-LAST:event_bModificaActionPerformed

    private void bBorraActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bBorraActionPerformed
        int aux;
        if (gLista.getSelectedIndex()!=-1){
            aux=((IElemento)gLista.getSelectedValue()).dameId();
            String nombre=gLista.getSelectedValue().toString();
            int seleccion= JOptionPane.showConfirmDialog(null,"¿Desea borrar a " + nombre + "?",
                                            "Advertencia", JOptionPane.YES_NO_OPTION);
            if (seleccion==JOptionPane.YES_OPTION){
                String r=miGestor.Borra(aux);
                if (!r.substring(0, 2).equals("OK")){
                    JOptionPane.showMessageDialog(this, r);
                }
            }
        }
    }//GEN-LAST:event_bBorraActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton bBorra;
    private javax.swing.JButton bBusca;
    private javax.swing.JButton bModifica;
    private javax.swing.JButton bNuevo;
    private javax.swing.JButton bSalir;
    private javax.swing.JList gLista;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextField tCadena;
    // End of variables declaration//GEN-END:variables
}
