/*Esta interfaz se implementa siempre y cuando el elemento tenga
 * una clave int y un nombre string
 */
package lib;

import java.util.ArrayList;

/**
 *
 * @author maxio
 */
public interface IGestor {
    /**
     * Método que guarda en la base de datos el elemento, en su tabla correspondiente.
     * Hay que llamar al stored procedure correspondiente.
     *
     * @param elemento Que debe ser de la clase correspondiente al gestor
     * @return String Cadena que cuando el procedimiento tiene éxito tiene la forma OKNN, con NN el entero de la clave de la tabla del nuevo elemento.
     * Cualquier otra cadena es el mensaje de error.
     */
    public String Nuevo (Object elemento);
    /**
     *
     * @param elemento
     * @return
     */
    public String Modifica (Object elemento);
    /**
     *
     * @param id
     * @return
     */
    public String Borra (int id);
    /**
     *
     * @param tipo
     * @param cadena
     * @return
     */
    public ArrayList Buscar (String tipo, String cadena);
}
